"use strict";

var _reactDom = _interopRequireDefault(require("react-dom"));

var _react = _interopRequireWildcard(require("react"));

var _ = require("./");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

//
// const setConfiguration = (configuration) => {
//   return (dispatch, getState) => {
//     if (!getState().configuration.initialized) {
//       dispatch({
//         type: 'SET_CONFIGURATION',
//         configuration
//       })
//     }
//   };
// };
//
// const defaultState = {
//   initialized: false,
//   app: {
//     mode: undefined
//   }
// };
//
// const configuration = (state = defaultState, action) => {
//   switch (action.type) {
//     case 'SET_CONFIGURATION':
//       return { ...state, ...action.configuration };
//     default:
//       return state;
//   }
// };
//
// const store = createStore(combineReducers({configuration}), {}, applyMiddleware(thunk));
var features = {
  project: {
    lang: {
      french: {
        active: false
      }
    },
    feature1: {
      active: true
    },
    feature2: {
      active: true
    }
  }
};
var fallback = {
  project: {
    lang: {
      french: {
        active: false
      }
    },
    feature1: {
      active: false
    },
    feature2: {
      active: true
    },
    feature3: {
      active: false
    }
  }
};

var App =
/*#__PURE__*/
function (_Component) {
  _inherits(App, _Component);

  function App() {
    _classCallCheck(this, App);

    return _possibleConstructorReturn(this, _getPrototypeOf(App).apply(this, arguments));
  }

  _createClass(App, [{
    key: "render",
    // componentDidMount() {
    //   store.dispatch(setConfiguration({
    //     initialized: true,
    //     app: {
    //       mode: "test"
    //     }
    //   }));
    // }
    value: function render() {
      var _this = this;

      //<Provider store={store}>
      return _react.default.createElement(_.IzanamiProvider, {
        id: "provider1",
        fetchFrom: function fetchFrom() {
          return fetch("/api/izanami", {
            method: 'GET',
            credentials: 'include',
            headers: _this.props.fetchHeaders
          });
        },
        featuresFallback: fallback
      }, _react.default.createElement("div", null, _react.default.createElement(FeatureApp, null), _react.default.createElement("div", null, _react.default.createElement(_.Feature, {
        debug: true,
        path: "project.feature1"
      }, _react.default.createElement("p", null, "Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.")))));
    } // </Provider>

  }]);

  return App;
}(_react.Component);

var FeatureApp =
/*#__PURE__*/
function (_Component2) {
  _inherits(FeatureApp, _Component2);

  function FeatureApp() {
    _classCallCheck(this, FeatureApp);

    return _possibleConstructorReturn(this, _getPrototypeOf(FeatureApp).apply(this, arguments));
  }

  _createClass(FeatureApp, [{
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement(_.Feature, {
        debug: true,
        path: "project.lang.french"
      }, _react.default.createElement(_.Enabled, null, _react.default.createElement("h1", null, "Salut le monde !")), _react.default.createElement(_.Disabled, null, _react.default.createElement("h1", null, "Hello World!"))), _react.default.createElement(_.Feature, {
        debug: true,
        path: ["project.feature2", "project.feature3"]
      }, _react.default.createElement(_.Enabled, null, _react.default.createElement("h1", null, "Actif")), _react.default.createElement(_.Disabled, null, _react.default.createElement("h1", null, "Inactif"))));
    }
  }]);

  return FeatureApp;
}(_react.Component); // const FeatureApp = connect(store => {
//   console.log(store);
//   return store.configuration.app;
// })(FeatureAppComponent);


var experiments = {
  project: {
    lang: {
      french: {
        variant: 'A'
      }
    }
  }
};
var experimentsFallback = {
  project: {
    lang: {
      french: {
        variant: 'B'
      }
    }
  }
};

var AppAB =
/*#__PURE__*/
function (_Component3) {
  _inherits(AppAB, _Component3);

  function AppAB() {
    _classCallCheck(this, AppAB);

    return _possibleConstructorReturn(this, _getPrototypeOf(AppAB).apply(this, arguments));
  }

  _createClass(AppAB, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_.IzanamiProvider, {
        id: "provider2",
        fetchFrom: function fetchFrom() {
          return fetch("/api/izanami", {
            method: 'GET',
            credentials: 'include',
            headers: _this2.props.fetchHeaders
          });
        },
        featuresFallback: fallback,
        experimentsFallback: experimentsFallback
      }, _react.default.createElement("div", null, _react.default.createElement(_.Experiment, {
        debug: true,
        path: "project.lang.french",
        default: "B"
      }, _react.default.createElement(_.Variant, {
        id: "A"
      }, _react.default.createElement("h1", null, "Salut le monde !")), _react.default.createElement(_.Variant, {
        id: "B"
      }, _react.default.createElement("h1", null, "Salut les biatchs !")))));
    }
  }]);

  return AppAB;
}(_react.Component);

_reactDom.default.render(_react.default.createElement(App, null), document.getElementById('app'));

_reactDom.default.render(_react.default.createElement(AppAB, null), document.getElementById('app2'));